/**
 *
 *  Class Diagram.java
 *
 *  Generated by KMF [ToolGen] at 30 April 2003 10:26:37
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.implementation;

import java.io.*;
import uk.ac.ukc.cs.kmf.util.*;
import uk.ac.ukc.cs.kmf.ocl.*;
import uk.ac.ukc.cs.kmf.ocl.exceptions.*;
import uk.ac.ukc.cs.kmf.ocl.implementations.*;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsLifecycle;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsVisitor;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsVisitable;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsElement;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.IConstraintDiagramsEnum;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.*;

public class Diagram
  extends OclAny
  implements IDiagram,
             IConstraintDiagramsVisitable
{
  //--- Constructors ---
  public Diagram() {
    //--- Properties for 'Diagram' ---
    //--- Attributes ---
    //--- Associations ---
    this._r_zone = OCL.MutableSet();
    this._r_spider = OCL.MutableSet();
    this._r_contour = OCL.MutableSet();
    this._r_arrow = OCL.MutableSet();
    this._r_boundary = null;
    //--- Invariants ---
    this.zone_size = OCL.Invariant(this, "context Diagram inv zone_size : 1<=zone->size()");
    this.zone_bidirectional = OCL.Invariant(this, "context Diagram inv zone_bidirectional : zone->forAll(x | x.diagram=self)");
    this.spider_size = OCL.Invariant(this, "context Diagram inv spider_size : 0<=spider->size()");
    this.contour_size = OCL.Invariant(this, "context Diagram inv contour_size : 1<=contour->size()");
    this.contour_bidirectional = OCL.Invariant(this, "context Diagram inv contour_bidirectional : contour->forAll(x | x.diagram=self)");
    this.arrow_size = OCL.Invariant(this, "context Diagram inv arrow_size : 0<=arrow->size()");
    this.arrow_bidirectional = OCL.Invariant(this, "context Diagram inv arrow_bidirectional : arrow->forAll(x | x.diagram=self)");
  }

  //--- Identifier ---
  protected String id;
  public void setId(String id) {
    this.id = id;
  }
  public String getId() {
    return id;
  }

  //--- Invariants ---
  //--- Invariants for Diagram ---
  IOclInvariant zone_size;
  public IOclInvariant zone_size() { return zone_size; }
  IOclInvariant zone_bidirectional;
  public IOclInvariant zone_bidirectional() { return zone_bidirectional; }
  IOclInvariant spider_size;
  public IOclInvariant spider_size() { return spider_size; }
  IOclInvariant contour_size;
  public IOclInvariant contour_size() { return contour_size; }
  IOclInvariant contour_bidirectional;
  public IOclInvariant contour_bidirectional() { return contour_bidirectional; }
  IOclInvariant arrow_size;
  public IOclInvariant arrow_size() { return arrow_size; }
  IOclInvariant arrow_bidirectional;
  public IOclInvariant arrow_bidirectional() { return arrow_bidirectional; }
  //--- ParseAll ---
  public IBoolean inv_ParseAll(ILog log) {
    boolean res = true;
    String str = new String();
    str += "Parsing invariants from "+this+"\n";
    try {
       str += "  "+"zone_size: ";
       zone_size().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"zone_bidirectional: ";
       zone_bidirectional().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"spider_size: ";
       spider_size().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"contour_size: ";
       contour_size().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"contour_bidirectional: ";
       contour_bidirectional().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"arrow_size: ";
       arrow_size().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    try {
       str += "  "+"arrow_bidirectional: ";
       arrow_bidirectional().parse();
       str += "ok\n";
    } catch(ParserException e) {
       res = false;
       str += "syntax error\n";
    } catch(Exception e) {
       res = false;
       str += "translation error\n";
    }
    log.reportMessage(str);
    return OCL.Boolean(res);
  }
  //--- EvaluateAll ---
  public IBoolean inv_EvaluateAll(ILog log) {
    boolean res = true;
    String str = new String();
    str += "Evaluating invariants from "+this+"\n";
    try {
      str += "  "+"zone_size: ";
      boolean inv = OCL.impl((IBoolean)zone_size().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"zone_bidirectional: ";
      boolean inv = OCL.impl((IBoolean)zone_bidirectional().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"spider_size: ";
      boolean inv = OCL.impl((IBoolean)spider_size().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"contour_size: ";
      boolean inv = OCL.impl((IBoolean)contour_size().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"contour_bidirectional: ";
      boolean inv = OCL.impl((IBoolean)contour_bidirectional().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"arrow_size: ";
      boolean inv = OCL.impl((IBoolean)arrow_size().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    try {
      str += "  "+"arrow_bidirectional: ";
      boolean inv = OCL.impl((IBoolean)arrow_bidirectional().evaluate());
      res = res && inv;
      str += inv + "\n";
    } catch(ParserException e) {
      res = false;
      str += "syntax error\n";
    } catch(Exception e) {
      res = false;
      str += "undefined\n";
    }
    str += "Evaluation result = " + res;
    log.reportMessage(str);
    return OCL.Boolean(res);
  }

  //--- Accept ---
  public Object accept(IConstraintDiagramsVisitor v, Object obj) {
    return v.visit(this, obj);
  }

  //--- ToString ---
  public String toString() {
    String strId = "id";
    try {
        java.lang.Class cls = this.getClass();
        java.lang.reflect.Method method = cls.getMethod("name", new java.lang.Class[] {});
        strId = OCL.impl((IString) method.invoke(this, new Object[] {}));
    } catch (Exception e) {
    }
    if (strId.equals("")) strId = "id";
    return "Diagram '"+strId+"-"+getId()+"'";
  }

  //--- Equals ---
  public boolean equals(Object o) {
    return this == o;
  }

  //--- Clone ---
  public Object clone() {
    Diagram obj = new Diagram();
    obj._r_zone = _r_zone==null ? null : (IMutableSet)this._r_zone.clone();
    obj._r_spider = _r_spider==null ? null : (IMutableSet)this._r_spider.clone();
    obj._r_contour = _r_contour==null ? null : (IMutableSet)this._r_contour.clone();
    obj._r_arrow = _r_arrow==null ? null : (IMutableSet)this._r_arrow.clone();
    obj._r_boundary = _r_boundary==null ? null : (IContour)this._r_boundary;
    return obj;
  }

  //--- Properties ---
  //--- Attributes for Diagram ---
  //--- AssociationEnds for Diagram ---
  IMutableSet _r_zone;
  public IMutableSet zone() {return _r_zone;}
  public void setZone(IMutableSet zone) {
    _r_zone=zone;
  }

  IMutableSet _r_spider;
  public IMutableSet spider() {return _r_spider;}
  public void setSpider(IMutableSet spider) {
    _r_spider=spider;
  }

  IMutableSet _r_contour;
  public IMutableSet contour() {return _r_contour;}
  public void setContour(IMutableSet contour) {
    _r_contour=contour;
  }

  IMutableSet _r_arrow;
  public IMutableSet arrow() {return _r_arrow;}
  public void setArrow(IMutableSet arrow) {
    _r_arrow=arrow;
  }

  IContour _r_boundary;
  public IContour boundary() {return _r_boundary;}
  public void setBoundary(IContour boundary) {
    _r_boundary=boundary;
  }

  //--- Operations for Diagram ---
}
