/**
 *
 *  Class vsmlEvaluateAllVisitor.java
 *
 *  Generated by KMFStudio at 22 May 2003 20:30:37
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.kmf.studio.vsml;

import java.util.*;

import uk.ac.ukc.cs.kmf.util.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Parser.*;
import uk.ac.ukc.cs.kmf.ocl20.Syntax.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Bridge.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.*;
import uk.ac.ukc.cs.kmf.ocl20.Semantics.Contexts.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.*;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.*;

import uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.Association;

public class vsmlEvaluateAllVisitor$Class
	extends vsmlVisitor$Class
	implements vsmlEvaluateAllVisitor
{
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv owner_bidirectional: Set{owner}->forAll(x | x.associationEnd->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t1 = OCL.Set();
			Association t2 = (Association)self.getOwner();
			t1 = t1.including(t2);
			Association x = null;
			IOclBoolean t3 = OCL.Boolean(true);
			java.util.Iterator t4 = OCL.impl(t1).iterator();
			while (t4.hasNext()) {
			    x = (Association)t4.next();
			    IOclOrderedSet t5 = OCL.OrderedSet(x.getAssociationEnd());
			    IOclBoolean t6 = (IOclBoolean)t5.includes(self);
			    t3 = t6;
			    if(!OCL.impl(t3)) break;
			}
			log.reportMessage(": "+t3);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv target_bidirectional: Set{target}->forAll(x | x.targetOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t7 = OCL.Set();
			Class_ t8 = (Class_)self.getTarget();
			t7 = t7.including(t8);
			Class_ x = null;
			IOclBoolean t9 = OCL.Boolean(true);
			java.util.Iterator t10 = OCL.impl(t7).iterator();
			while (t10.hasNext()) {
			    x = (Class_)t10.next();
			    IOclSet t11 = OCL.Set(x.getTargetOf());
			    IOclBoolean t12 = (IOclBoolean)t11.includes(self);
			    t9 = t12;
			    if(!OCL.impl(t9)) break;
			}
			log.reportMessage(": "+t9);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv source_bidirectional: Set{source}->forAll(x | x.sourceOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t13 = OCL.Set();
			Class_ t14 = (Class_)self.getSource();
			t13 = t13.including(t14);
			Class_ x = null;
			IOclBoolean t15 = OCL.Boolean(true);
			java.util.Iterator t16 = OCL.impl(t13).iterator();
			while (t16.hasNext()) {
			    x = (Class_)t16.next();
			    IOclSet t17 = OCL.Set(x.getSourceOf());
			    IOclBoolean t18 = (IOclBoolean)t17.includes(self);
			    t15 = t18;
			    if(!OCL.impl(t15)) break;
			}
			log.reportMessage(": "+t15);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_source_is_target : otherEnd -> isEmpty() or ( otherEnd . target = source and otherEnd . source = target )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t19;
			try {
			    IOclSet t20 = OCL.Set();
			    AssociationEnd t21 = (AssociationEnd)self.getOtherEnd();
			    t20 = t20.including(t21);
			    IOclBoolean t22 = (IOclBoolean)t20.isEmpty();
			    t19 = t22;
			} catch (Exception e) {
			    t19 = OCL.Undefined();
			}
			IOclBoolean t23;
			try {
			    // 'and'
			    IOclBoolean t24;
			    try {
			        AssociationEnd t25 = (AssociationEnd)self.getOtherEnd();
			        Class_ t26 = (Class_)t25.getTarget();
			        Class_ t27 = (Class_)self.getSource();
			        IOclBoolean t28 = OCL.equalTo(t26, t27);
			        t24 = t28;
			    } catch (Exception e) {
			        t24 = OCL.Undefined();
			    }
			    IOclBoolean t29;
			    try {
			        AssociationEnd t30 = (AssociationEnd)self.getOtherEnd();
			        Class_ t31 = (Class_)t30.getSource();
			        Class_ t32 = (Class_)self.getTarget();
			        IOclBoolean t33 = OCL.equalTo(t31, t32);
			        t29 = t33;
			    } catch (Exception e) {
			        t29 = OCL.Undefined();
			    }
			    IOclBoolean t34 = OCL.andOper(t24, t29);
			    t23 = t34;
			} catch (Exception e) {
			    t23 = OCL.Undefined();
			}
			IOclBoolean t35 = OCL.orOper(t19, t23);
			log.reportMessage(": "+t35);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv upper_greater_than_lower : upper -> isEmpty() or upper >= lower";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t36;
			try {
			    IOclSet t37 = OCL.Set();
			    IOclInteger t38 = OCL.Integer(self.getUpper());
			    t37 = t37.including(t38);
			    IOclBoolean t39 = (IOclBoolean)t37.isEmpty();
			    t36 = t39;
			} catch (Exception e) {
			    t36 = OCL.Undefined();
			}
			IOclBoolean t40;
			try {
			    IOclInteger t41 = OCL.Integer(self.getUpper());
			    IOclInteger t42 = OCL.Integer(self.getLower());
			    IOclBoolean t43 = (IOclBoolean)t41.greaterThanOrEqualTo(t42);
			    t40 = t43;
			} catch (Exception e) {
			    t40 = OCL.Undefined();
			}
			IOclBoolean t44 = OCL.orOper(t36, t40);
			log.reportMessage(": "+t44);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::AssociationEnd inv otherEnd_owner_is_owner_and_not_self : otherEnd -> isEmpty() or ( otherEnd . owner = owner and not ( otherEnd = self ) )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t45;
			try {
			    IOclSet t46 = OCL.Set();
			    AssociationEnd t47 = (AssociationEnd)self.getOtherEnd();
			    t46 = t46.including(t47);
			    IOclBoolean t48 = (IOclBoolean)t46.isEmpty();
			    t45 = t48;
			} catch (Exception e) {
			    t45 = OCL.Undefined();
			}
			IOclBoolean t49;
			try {
			    // 'and'
			    IOclBoolean t50;
			    try {
			        AssociationEnd t51 = (AssociationEnd)self.getOtherEnd();
			        Association t52 = (Association)t51.getOwner();
			        Association t53 = (Association)self.getOwner();
			        IOclBoolean t54 = OCL.equalTo(t52, t53);
			        t50 = t54;
			    } catch (Exception e) {
			        t50 = OCL.Undefined();
			    }
			    IOclBoolean t55;
			    try {
			        // 'not'
			        IOclBoolean t56;
			        try {
			            AssociationEnd t57 = (AssociationEnd)self.getOtherEnd();
			            IOclBoolean t58 = OCL.equalTo(t57, self);
			            t56 = t58;
			        } catch (Exception e) {
			            t56 = OCL.Undefined();
			        }
			        IOclBoolean t59 = OCL.notOper(t56);
			        t55 = t59;
			    } catch (Exception e) {
			        t55 = OCL.Undefined();
			    }
			    IOclBoolean t60 = OCL.andOper(t50, t55);
			    t49 = t60;
			} catch (Exception e) {
			    t49 = OCL.Undefined();
			}
			IOclBoolean t61 = OCL.orOper(t45, t49);
			log.reportMessage(": "+t61);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv targetOf_size: 0<=targetOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t62 = OCL.Set(self.getTargetOf());
			IOclInteger t63 = (IOclInteger)t62.size();
			IOclBoolean t64 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t63);
			log.reportMessage(": "+t64);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv targetOf_bidirectional: targetOf->forAll(x | x.target=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t65 = OCL.Set(self.getTargetOf());
			AssociationEnd x = null;
			IOclBoolean t66 = OCL.Boolean(true);
			java.util.Iterator t67 = OCL.impl(t65).iterator();
			while (t67.hasNext()) {
			    x = (AssociationEnd)t67.next();
			    Class_ t68 = (Class_)x.getTarget();
			    IOclBoolean t69 = OCL.equalTo(t68, self);
			    t66 = t69;
			    if(!OCL.impl(t66)) break;
			}
			log.reportMessage(": "+t66);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv sourceOf_size: 0<=sourceOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t70 = OCL.Set(self.getSourceOf());
			IOclInteger t71 = (IOclInteger)t70.size();
			IOclBoolean t72 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t71);
			log.reportMessage(": "+t72);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv sourceOf_bidirectional: sourceOf->forAll(x | x.source=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t73 = OCL.Set(self.getSourceOf());
			AssociationEnd x = null;
			IOclBoolean t74 = OCL.Boolean(true);
			java.util.Iterator t75 = OCL.impl(t73).iterator();
			while (t75.hasNext()) {
			    x = (AssociationEnd)t75.next();
			    Class_ t76 = (Class_)x.getSource();
			    IOclBoolean t77 = OCL.equalTo(t76, self);
			    t74 = t77;
			    if(!OCL.impl(t74)) break;
			}
			log.reportMessage(": "+t74);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv owner_bidirectional: Set{owner}->forAll(x | x.class_->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t78 = OCL.Set();
			Package_ t79 = (Package_)self.getOwner();
			t78 = t78.including(t79);
			Package_ x = null;
			IOclBoolean t80 = OCL.Boolean(true);
			java.util.Iterator t81 = OCL.impl(t78).iterator();
			while (t81.hasNext()) {
			    x = (Package_)t81.next();
			    IOclSet t82 = OCL.Set(x.getClass_());
			    IOclBoolean t83 = (IOclBoolean)t82.includes(self);
			    t80 = t83;
			    if(!OCL.impl(t80)) break;
			}
			log.reportMessage(": "+t80);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv superClass_size: 0<=superClass->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t84 = OCL.Set(self.getSuperClass());
			IOclInteger t85 = (IOclInteger)t84.size();
			IOclBoolean t86 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t85);
			log.reportMessage(": "+t86);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Class_ inv names_of_assoc_ends_are_unique : sourceOf . name -> asSet() -> asBag() = sourceOf . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t87 = OCL.Set(self.getSourceOf());
			AssociationEnd _tempIt1 = null;
			IOclBag t88 = OCL.Bag();;
			java.util.Iterator t89 = OCL.impl(t87).iterator();
			while (t89.hasNext()) {
			    _tempIt1 = (AssociationEnd)t89.next();
			    IOclString t90 = OCL.String(_tempIt1.getName());
			    t88 = t88.including(t90);
			}
			t88 = t88.flatten();
			IOclSet t91 = (IOclSet)t88.asSet();
			IOclBag t92 = (IOclBag)t91.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t93 = OCL.Set(self.getSourceOf());
			AssociationEnd _tempIt0 = null;
			IOclBag t94 = OCL.Bag();;
			java.util.Iterator t95 = OCL.impl(t93).iterator();
			while (t95.hasNext()) {
			    _tempIt0 = (AssociationEnd)t95.next();
			    IOclString t96 = OCL.String(_tempIt0.getName());
			    t94 = t94.including(t96);
			}
			t94 = t94.flatten();
			IOclBoolean t97 = OCL.equalTo(t92, t94);
			log.reportMessage(": "+t97);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class__size: 0<=class_->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t98 = OCL.Set(self.getClass_());
			IOclInteger t99 = (IOclInteger)t98.size();
			IOclBoolean t100 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t99);
			log.reportMessage(": "+t100);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class__bidirectional: class_->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t101 = OCL.Set(self.getClass_());
			Class_ x = null;
			IOclBoolean t102 = OCL.Boolean(true);
			java.util.Iterator t103 = OCL.impl(t101).iterator();
			while (t103.hasNext()) {
			    x = (Class_)t103.next();
			    Package_ t104 = (Package_)x.getOwner();
			    IOclBoolean t105 = OCL.equalTo(t104, self);
			    t102 = t105;
			    if(!OCL.impl(t102)) break;
			}
			log.reportMessage(": "+t102);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv owner_bidirectional: Set{owner}->forAll(x | x.package_->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t106 = OCL.Set();
			Package_ t107 = (Package_)self.getOwner();
			t106 = t106.including(t107);
			Package_ x = null;
			IOclBoolean t108 = OCL.Boolean(true);
			java.util.Iterator t109 = OCL.impl(t106).iterator();
			while (t109.hasNext()) {
			    x = (Package_)t109.next();
			    IOclSet t110 = OCL.Set(x.getPackage_());
			    IOclBoolean t111 = (IOclBoolean)t110.includes(self);
			    t108 = t111;
			    if(!OCL.impl(t108)) break;
			}
			log.reportMessage(": "+t108);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package__size: 0<=package_->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t112 = OCL.Set(self.getPackage_());
			IOclInteger t113 = (IOclInteger)t112.size();
			IOclBoolean t114 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t113);
			log.reportMessage(": "+t114);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package__bidirectional: package_->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t115 = OCL.Set(self.getPackage_());
			Package_ x = null;
			IOclBoolean t116 = OCL.Boolean(true);
			java.util.Iterator t117 = OCL.impl(t115).iterator();
			while (t117.hasNext()) {
			    x = (Package_)t117.next();
			    Package_ t118 = (Package_)x.getOwner();
			    IOclBoolean t119 = OCL.equalTo(t118, self);
			    t116 = t119;
			    if(!OCL.impl(t116)) break;
			}
			log.reportMessage(": "+t116);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv association_size: 0<=association->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t120 = OCL.Set(self.getAssociation());
			IOclInteger t121 = (IOclInteger)t120.size();
			IOclBoolean t122 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t121);
			log.reportMessage(": "+t122);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv association_bidirectional: association->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t123 = OCL.Set(self.getAssociation());
			Association x = null;
			IOclBoolean t124 = OCL.Boolean(true);
			java.util.Iterator t125 = OCL.impl(t123).iterator();
			while (t125.hasNext()) {
			    x = (Association)t125.next();
			    Package_ t126 = (Package_)x.getOwner();
			    IOclBoolean t127 = OCL.equalTo(t126, self);
			    t124 = t127;
			    if(!OCL.impl(t124)) break;
			}
			log.reportMessage(": "+t124);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv package_names_unique : package_ . name -> asSet() -> asBag() = package_ . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t128 = OCL.Set(self.getPackage_());
			Package_ _tempIt3 = null;
			IOclBag t129 = OCL.Bag();;
			java.util.Iterator t130 = OCL.impl(t128).iterator();
			while (t130.hasNext()) {
			    _tempIt3 = (Package_)t130.next();
			    IOclString t131 = OCL.String(_tempIt3.getName());
			    t129 = t129.including(t131);
			}
			t129 = t129.flatten();
			IOclSet t132 = (IOclSet)t129.asSet();
			IOclBag t133 = (IOclBag)t132.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t134 = OCL.Set(self.getPackage_());
			Package_ _tempIt2 = null;
			IOclBag t135 = OCL.Bag();;
			java.util.Iterator t136 = OCL.impl(t134).iterator();
			while (t136.hasNext()) {
			    _tempIt2 = (Package_)t136.next();
			    IOclString t137 = OCL.String(_tempIt2.getName());
			    t135 = t135.including(t137);
			}
			t135 = t135.flatten();
			IOclBoolean t138 = OCL.equalTo(t133, t135);
			log.reportMessage(": "+t138);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv assoc_names_unique : association . name -> asSet() -> asBag() = association . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t139 = OCL.Set(self.getAssociation());
			Association _tempIt5 = null;
			IOclBag t140 = OCL.Bag();;
			java.util.Iterator t141 = OCL.impl(t139).iterator();
			while (t141.hasNext()) {
			    _tempIt5 = (Association)t141.next();
			    IOclString t142 = OCL.String(_tempIt5.getName());
			    t140 = t140.including(t142);
			}
			t140 = t140.flatten();
			IOclSet t143 = (IOclSet)t140.asSet();
			IOclBag t144 = (IOclBag)t143.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t145 = OCL.Set(self.getAssociation());
			Association _tempIt4 = null;
			IOclBag t146 = OCL.Bag();;
			java.util.Iterator t147 = OCL.impl(t145).iterator();
			while (t147.hasNext()) {
			    _tempIt4 = (Association)t147.next();
			    IOclString t148 = OCL.String(_tempIt4.getName());
			    t146 = t146.including(t148);
			}
			t146 = t146.flatten();
			IOclBoolean t149 = OCL.equalTo(t144, t146);
			log.reportMessage(": "+t149);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Package_ inv class_names_unique : class_ . name -> asSet() -> asBag() = class_ . name";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t150 = OCL.Set(self.getClass_());
			Class_ _tempIt7 = null;
			IOclBag t151 = OCL.Bag();;
			java.util.Iterator t152 = OCL.impl(t150).iterator();
			while (t152.hasNext()) {
			    _tempIt7 = (Class_)t152.next();
			    IOclString t153 = OCL.String(_tempIt7.getName());
			    t151 = t151.including(t153);
			}
			t151 = t151.flatten();
			IOclSet t154 = (IOclSet)t151.asSet();
			IOclBag t155 = (IOclBag)t154.asBag();
			// 'collect' iterator
			// 'collectedNested' iterator
			IOclSet t156 = OCL.Set(self.getClass_());
			Class_ _tempIt6 = null;
			IOclBag t157 = OCL.Bag();;
			java.util.Iterator t158 = OCL.impl(t156).iterator();
			while (t158.hasNext()) {
			    _tempIt6 = (Class_)t158.next();
			    IOclString t159 = OCL.String(_tempIt6.getName());
			    t157 = t157.including(t159);
			}
			t157 = t157.flatten();
			IOclBoolean t160 = OCL.equalTo(t155, t157);
			log.reportMessage(": "+t160);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.kmf.studio.vsml.AS.Association' */
	public Object visit(uk.ac.ukc.cs.kmf.studio.vsml.AS.Association self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv associationEnd_size: 1<=associationEnd->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclOrderedSet t161 = OCL.OrderedSet(self.getAssociationEnd());
			IOclInteger t162 = (IOclInteger)t161.size();
			IOclBoolean t163 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t162);
			log.reportMessage(": "+t163);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv associationEnd_bidirectional: associationEnd->forAll(x | x.owner=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclOrderedSet t164 = OCL.OrderedSet(self.getAssociationEnd());
			AssociationEnd x = null;
			IOclBoolean t165 = OCL.Boolean(true);
			java.util.Iterator t166 = OCL.impl(t164).iterator();
			while (t166.hasNext()) {
			    x = (AssociationEnd)t166.next();
			    Association t167 = (Association)x.getOwner();
			    IOclBoolean t168 = OCL.equalTo(t167, self);
			    t165 = t168;
			    if(!OCL.impl(t165)) break;
			}
			log.reportMessage(": "+t165);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv owner_bidirectional: Set{owner}->forAll(x | x.association->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t169 = OCL.Set();
			Package_ t170 = (Package_)self.getOwner();
			t169 = t169.including(t170);
			Package_ x = null;
			IOclBoolean t171 = OCL.Boolean(true);
			java.util.Iterator t172 = OCL.impl(t169).iterator();
			while (t172.hasNext()) {
			    x = (Package_)t172.next();
			    IOclSet t173 = OCL.Set(x.getAssociation());
			    IOclBoolean t174 = (IOclBoolean)t173.includes(self);
			    t171 = t174;
			    if(!OCL.impl(t171)) break;
			}
			log.reportMessage(": "+t171);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Association inv one_at_other_of_two_and_vice_versa : associationEnd -> size() = 1 or ( associationEnd -> size() = 2 and associationEnd -> first() . otherEnd = associationEnd -> last() and associationEnd -> last() . otherEnd = associationEnd -> first() )";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'or'
			IOclBoolean t175;
			try {
			    IOclOrderedSet t176 = OCL.OrderedSet(self.getAssociationEnd());
			    IOclInteger t177 = (IOclInteger)t176.size();
			    IOclBoolean t178 = OCL.equalTo(t177, OCL.Integer(1));
			    t175 = t178;
			} catch (Exception e) {
			    t175 = OCL.Undefined();
			}
			IOclBoolean t179;
			try {
			    // 'and'
			    IOclBoolean t180;
			    try {
			        // 'and'
			        IOclBoolean t181;
			        try {
			            IOclOrderedSet t182 = OCL.OrderedSet(self.getAssociationEnd());
			            IOclInteger t183 = (IOclInteger)t182.size();
			            IOclBoolean t184 = OCL.equalTo(t183, OCL.Integer(2));
			            t181 = t184;
			        } catch (Exception e) {
			            t181 = OCL.Undefined();
			        }
			        IOclBoolean t185;
			        try {
			            IOclOrderedSet t186 = OCL.OrderedSet(self.getAssociationEnd());
			            AssociationEnd t187 = (AssociationEnd)t186.first();
			            AssociationEnd t188 = (AssociationEnd)t187.getOtherEnd();
			            IOclOrderedSet t189 = OCL.OrderedSet(self.getAssociationEnd());
			            AssociationEnd t190 = (AssociationEnd)t189.last();
			            IOclBoolean t191 = OCL.equalTo(t188, t190);
			            t185 = t191;
			        } catch (Exception e) {
			            t185 = OCL.Undefined();
			        }
			        IOclBoolean t192 = OCL.andOper(t181, t185);
			        t180 = t192;
			    } catch (Exception e) {
			        t180 = OCL.Undefined();
			    }
			    IOclBoolean t193;
			    try {
			        IOclOrderedSet t194 = OCL.OrderedSet(self.getAssociationEnd());
			        AssociationEnd t195 = (AssociationEnd)t194.last();
			        AssociationEnd t196 = (AssociationEnd)t195.getOtherEnd();
			        IOclOrderedSet t197 = OCL.OrderedSet(self.getAssociationEnd());
			        AssociationEnd t198 = (AssociationEnd)t197.first();
			        IOclBoolean t199 = OCL.equalTo(t196, t198);
			        t193 = t199;
			    } catch (Exception e) {
			        t193 = OCL.Undefined();
			    }
			    IOclBoolean t200 = OCL.andOper(t180, t193);
			    t179 = t200;
			} catch (Exception e) {
			    t179 = OCL.Undefined();
			}
			IOclBoolean t201 = OCL.orOper(t175, t179);
			log.reportMessage(": "+t201);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
}
